# coding: utf-8

"""
    Isilon SDK

    Isilon SDK - Language bindings for the OneFS API  # noqa: E501

    OpenAPI spec version: 3
    Contact: sdk@isilon.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from isi_sdk_8_0.models.auth_access_access_item_file import AuthAccessAccessItemFile  # noqa: F401,E501
from isi_sdk_8_0.models.auth_access_access_item_permissions import AuthAccessAccessItemPermissions  # noqa: F401,E501
from isi_sdk_8_0.models.auth_access_access_item_relevant_ace import AuthAccessAccessItemRelevantAce  # noqa: F401,E501
from isi_sdk_8_0.models.auth_access_access_item_user import AuthAccessAccessItemUser  # noqa: F401,E501


class AuthAccessAccessItem(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'file': 'AuthAccessAccessItemFile',
        'id': 'str',
        'permissions': 'AuthAccessAccessItemPermissions',
        'relevant_aces': 'list[AuthAccessAccessItemRelevantAce]',
        'user': 'AuthAccessAccessItemUser'
    }

    attribute_map = {
        'file': 'file',
        'id': 'id',
        'permissions': 'permissions',
        'relevant_aces': 'relevant_aces',
        'user': 'user'
    }

    def __init__(self, file=None, id=None, permissions=None, relevant_aces=None, user=None):  # noqa: E501
        """AuthAccessAccessItem - a model defined in Swagger"""  # noqa: E501

        self._file = None
        self._id = None
        self._permissions = None
        self._relevant_aces = None
        self._user = None
        self.discriminator = None

        if file is not None:
            self.file = file
        if id is not None:
            self.id = id
        if permissions is not None:
            self.permissions = permissions
        if relevant_aces is not None:
            self.relevant_aces = relevant_aces
        if user is not None:
            self.user = user

    @property
    def file(self):
        """Gets the file of this AuthAccessAccessItem.  # noqa: E501

        Specifies properties for access rights.  # noqa: E501

        :return: The file of this AuthAccessAccessItem.  # noqa: E501
        :rtype: AuthAccessAccessItemFile
        """
        return self._file

    @file.setter
    def file(self, file):
        """Sets the file of this AuthAccessAccessItem.

        Specifies properties for access rights.  # noqa: E501

        :param file: The file of this AuthAccessAccessItem.  # noqa: E501
        :type: AuthAccessAccessItemFile
        """

        self._file = file

    @property
    def id(self):
        """Gets the id of this AuthAccessAccessItem.  # noqa: E501

        Specifies the ID of the user.  # noqa: E501

        :return: The id of this AuthAccessAccessItem.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this AuthAccessAccessItem.

        Specifies the ID of the user.  # noqa: E501

        :param id: The id of this AuthAccessAccessItem.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def permissions(self):
        """Gets the permissions of this AuthAccessAccessItem.  # noqa: E501

        Specifies the permissions that the user has on the file.  # noqa: E501

        :return: The permissions of this AuthAccessAccessItem.  # noqa: E501
        :rtype: AuthAccessAccessItemPermissions
        """
        return self._permissions

    @permissions.setter
    def permissions(self, permissions):
        """Sets the permissions of this AuthAccessAccessItem.

        Specifies the permissions that the user has on the file.  # noqa: E501

        :param permissions: The permissions of this AuthAccessAccessItem.  # noqa: E501
        :type: AuthAccessAccessItemPermissions
        """

        self._permissions = permissions

    @property
    def relevant_aces(self):
        """Gets the relevant_aces of this AuthAccessAccessItem.  # noqa: E501

        Specifies a list of the relevant Access Control Entries for the user.  # noqa: E501

        :return: The relevant_aces of this AuthAccessAccessItem.  # noqa: E501
        :rtype: list[AuthAccessAccessItemRelevantAce]
        """
        return self._relevant_aces

    @relevant_aces.setter
    def relevant_aces(self, relevant_aces):
        """Sets the relevant_aces of this AuthAccessAccessItem.

        Specifies a list of the relevant Access Control Entries for the user.  # noqa: E501

        :param relevant_aces: The relevant_aces of this AuthAccessAccessItem.  # noqa: E501
        :type: list[AuthAccessAccessItemRelevantAce]
        """

        self._relevant_aces = relevant_aces

    @property
    def user(self):
        """Gets the user of this AuthAccessAccessItem.  # noqa: E501

        Specifies the persona for the user.  # noqa: E501

        :return: The user of this AuthAccessAccessItem.  # noqa: E501
        :rtype: AuthAccessAccessItemUser
        """
        return self._user

    @user.setter
    def user(self, user):
        """Sets the user of this AuthAccessAccessItem.

        Specifies the persona for the user.  # noqa: E501

        :param user: The user of this AuthAccessAccessItem.  # noqa: E501
        :type: AuthAccessAccessItemUser
        """

        self._user = user

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AuthAccessAccessItem):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
